#include <iostream.h>
#include <fstream.h>
#include <list.h>
#include <string>

#define open  -1
#define close -2

char operators[12];
long left;
list<long> data;
int ops;
bool success;

long calc(list<long>::iterator &i, int &op) {
  long l;
  if (*i==open) {
    l=calc(++i, op);
    i++;
  }
  else if (*i>=0) {
    l=*i;
    i++;
  }
  
  while (i!=data.end() && *i!=close) {
    char c=operators[op++];
    long r;
    
    if (*i==open) {
      r=calc(++i, op);
      i++;
    }
    else if (*i>=0) {
      r=*i;
      i++;
    }
    if (c=='+')
      l+=r;
    else if (c=='-')
      l-=r;
    else if (c=='*')
      l*=r;
  }
  return l;
}

void count(list<long>::iterator &i) {
  if (*i==open) {
    count(++i);
    i++;
  }
  else if (*i>=0) {
    i++;
  }
  
  while (i!=data.end() && *i!=close) {
    ops++;
    
    if (*i==open) {
      count(++i);
      i++;
    }
    else if (*i>=0) {
      i++;
    }
  }
}

bool buildops(int depth) {
  if (depth==ops) {
    list<long>::iterator i=data.begin();
    int op=0;
    return (left==calc(i, op));
  } else {
    operators[depth] = '+';
    if (buildops(depth+1))
      return true;
    operators[depth] = '-';
    if (buildops(depth+1))
      return true;
    operators[depth] = '*';
    if (buildops(depth+1))
      return true;
    return false;
  }
}

int main(void)
{
  ifstream fin("dreisam.in");

  int N=0;
  while (fin >> left && left) {
    data.clear();
    char dummy;
    fin >> dummy;
    string s;
    getline(fin, s);
    s = s+' ';
    long num=0;
    bool havenum=false;
    ops=0;
    for (int i=0; i<s.length(); i++) {
      if (s[i]>='0' && s[i]<='9') {
	if (!havenum) {
	  num=0;
	  havenum=true;
	}
	num=num*10+(s[i]-'0');
      } else {
	if (havenum) {
	  data.push_back(num);
	  havenum = false;
	}
	if (s[i]=='(') {
	  data.push_back(open);
	}
	else if (s[i]==')') 
	  data.push_back(close);
      }
    }
    list<long>::iterator i=data.begin();
    count(i);
    success = buildops(0);
    cout << "Equation #" << ++N << ":" << endl;
    if (success) {
      cout << left << "=";
      bool need_op=false;
      int op=0;
      for (list<long>::iterator i=data.begin(); i!=data.end(); i++) {
	if (*i==open) {
	  if (need_op) {
	    cout << operators[op++];
	    need_op = false;
	  }
	  cout << "(";
	}
	else if (*i==close) {
	  cout << ")";
	  need_op = true;
	}
	else {
	  if (need_op) {
	    cout << operators[op++];
	    need_op = false;
	  }
	  cout << *i;
	  need_op = true;
	}
      }
      cout << endl;
    } else
      cout << "Impossible" << endl;
    cout << endl;
  }
  return 0;
}
