#include <iostream.h>
#include <fstream.h>
#include <queue>
#include <string>

struct Weg {
  int x, y, dir, len;
};

bool operator < (const Weg &w1, const Weg &w2) {
  return w1.len>w2.len;
}

class Kleiner {
public:
  bool operator () (const Weg &w1, const Weg &w2) const {
    return w1.len<w2.len;
  }
};

bool matrix[80][80];
int maxlen[80][80];
int w, h;

int disp[4][2] = {
  {-1, 0},
  {0, -1},
  {+1, 0},
  {0, +1}
};

bool drin(int x, int y) {
  return (x>=0 && y>=0 && x<=w+1 && y<=h+1);
}

int main(void)
{
  ifstream fin("game.in");

  int N=0;
  while (fin >> w >> h && w && h) {
    int x, y;
    string s;
    getline(fin, s);
    for (x=0; x<w+2; x++) 
      for (y=0; y<h+2; y++) {
	maxlen[x][y] = 100000000;
	matrix[x][y] = false;
      }
    
    for (y=0; y<h; y++) {
      getline(fin, s);
      cout << s << endl;

      for (x=0; x<w; x++) {
	matrix[x+1][y+1] = (x < s.length() && s[x]=='X');
	if (matrix[x+1][y+1])
	  maxlen[x+1][y+1] = 0;
	else
	  maxlen[x+1][y+1] = 100000000;
      }
    }

    cout << "Board #" << ++N << ":" << endl;

    int M=0;
    do {
      int x0, y0, x1, y1;
      fin >> x0 >> y0 >> x1 >> y1;
      if (!(x0|y0|x1|y1))
	break;

      priority_queue<Weg> pq;
      for (int i=0; i<4; i++) {
	Weg w;
	w.x = x0;
	w.y = y0;
	w.len=1;
	w.dir=i;
	pq.push(w);
      }

      int minlen=0;
      while (!pq.empty()) {
	Weg w=pq.top();
	pq.pop();

	if (w.x == x1 && w.y == y1) {
	  minlen = w.len;
	  break;
	} else
	  for (int i=0; i<4; i++) {
	    Weg v=w;
	    if (v.dir!=i)
	      v.len++;
	    v.dir = i;
	    v.x += disp[i][0];
	    v.y += disp[i][1];
	    
	    if (drin(v.x, v.y) && maxlen[v.x][v.y]>=v.len &&
		!matrix[v.x][v.y] ||
		(matrix[v.x][v.y] && (v.x==x1 && v.y==y1))) {
	      maxlen[v.x][v.y] = v.len;
	      pq.push(v);
	    }
	  }
      }
      
      cout << "Pair " << ++M << ": ";
      if (minlen) 
	cout << minlen << " segments.";
      else
	cout << "impossible.";
      cout << endl;
    } while (1);
    cout << endl;
  }
  return 0;
}
