#include <iostream.h>
#include <fstream.h>
#include <vector.h>
#include <map.h>
#include <string>

typedef map<int, vector<int> > TG;

TG G;
int w,h;

void ie(int x,int y, int a, int b)
{
  if (x<0 || y<0 || x>=w || y>=h) return;
  if (a<0 || b<0 || a>=w || b>=h) return;
  if ((y&1)==0 && (x>=w-1)) return;
  if ((b&1)==0 && (a>=w-1)) return;

  int v1=y*75+x, v2=b*75+a;

  //  cout << x << " " << y << " -> " << a << " " << b << endl;
  if (v1==v2) return;
  G[v1].push_back(v2);
  G[v2].push_back(v1);
}

int parent[76*76], da[76*76];
int length;
int maxlength;

int visit(int v)
{
  //  cout << v % 75 << " " << v/75 << endl;
  da[v]=1;

  vector<int>::iterator i=G[v].begin();
  while (i!=G[v].end()) {
    int w=*i;
    if (parent[w]==-1) parent[w]=v;
    if (parent[v] != w) {
      if (da[w]) return length+1;
      length++;
      int l=visit(w);
      if (l>0) return l;
    }
    i++;
  }
  return -1;
}

int main(void)
{
  ifstream fin("maze.in");
  int w1,h1;
  int x,y;
  string line;
  int maze_num=0;
  
  while ((fin >> w1 >> h1) && (w1||h1)) {
    int num_cyc=0;
    maze_num++;
    getline(fin, line);
    G.clear();
    w=w1;
    h=h1*2-1;
    for (int i=0; i<76*76; i++) {
      parent[i]=-1;
      da[i]=0;
    }
    length=0;
    x=-1; y=0;
    for (int linenum=0; linenum<h1; linenum++) {
      getline(fin, line);
      for (unsigned int i=0; i<line.length(); i++) {
	if (line[i]=='/') {
	  ie(x,y, x+1,y-1);
	  ie(x+1,y+1, x+1,y);
	} else {
	  ie(x,y, x+1,y+1);
	  ie(x+1,y-1, x+1,y);
	}
	x++;
      }
      x=-1;
      y+=2;
    }

    maxlength=0;
    for (y=0; y<h; y++) {
      for (x=0; x<w; x++) {
	if ((y&1)==0 && x==w-1) continue;
	int k=75*y+x;
	if (da[k]) continue;
	int l;
	length=0;
	l=visit(k);
	//	cout << l << " bbb\n";
	if (l>0) num_cyc++;
	if (l>maxlength) maxlength=l;
      }
    }

    cout << "Maze #" << maze_num << ":\n";
    if (num_cyc) {
      cout << num_cyc << " Cycles; the longest has length "
	   << maxlength << ".\n";
    } else {
      cout << "There are no cycles.\n";
    }
    cout << endl;
  }
  
  return 0;
}
